#ifndef ASTEROIDS_H
#define ASTEROIDS_H

#include <stdbool.h>

#include "effects.h"
#include "vec.h"

typedef struct {
	vec2f p;
	vec2f v;
	float r;
	float rotation;
	float rotationRate;
	int randomDisplacement;
	int life;
} asteroid_t;

typedef struct {
	vec2f p;
	vec2f v;
	float r;
	Plasma plasma;
	float life;
} missile_t;

typedef struct {
	vec2f p;
	vec2f v;
	float size;
	float heading;
	float w; /* angular speed */
	float a; /* acceleration/thrust */
	bool thruster;
	bool rThruster;
	bool turnRight;
	bool turnLeft;
	Engine engine;
	shipExplosion explosion;
	int lives;
	int score;
	float lastHit;
} ship_t;

#endif
