
#include "vec.h"

vec2f::vec2f()
{
}
vec2f::vec2f(float d)
{
	x = d;
	y = d;
}
vec2f::vec2f(float nx, float ny)
{
	x = nx;
	y = ny;
}
void vec2f::operator()(float d)
{
	x = d;
	y = d;
}
void vec2f::operator()(float nx, float ny)
{
	x = nx;
	y = ny;
}
void vec2f::operator=(float d)
{
	x = d;
	y = d;
}
bool vec2f::operator==(const vec2f& o)
{
	return x==o.x && y==o.y;
}
bool vec2f::operator!=(const vec2f& o)
{
	return x!=o.x && y!=o.y;
}
vec2f vec2f::operator+(const vec2f& o) const
{
	return vec2f(x+o.x, y+o.y);
}
void vec2f::operator+=(const vec2f& o)
{
	x += o.x;
	y += o.y;
}
vec2f vec2f::operator+(float d) const
{
	return vec2f(x+d, y+d);
}
void vec2f::operator+=(float d)
{
	x += d;
	y += d;
}
vec2f vec2f::operator-(const vec2f& o) const
{
	return vec2f(x-o.x, y-o.y);
}
void vec2f::operator-=(const vec2f& o)
{
	x -= o.x;
	y -= o.y;
}
vec2f vec2f::operator-(float d) const
{
	return vec2f(x-d, y-d);
}
void vec2f::operator-=(float d)
{
	x -= d;
	y -= d;
}
vec2f vec2f::operator/(const vec2f& o) const
{
	return vec2f(x/o.x, y/o.y);
}
void vec2f::operator/=(const vec2f& o)
{
	x /= o.x;
	y /= o.y;
}
vec2f vec2f::operator/(float d) const
{
	return vec2f(x/d, y/d);
}
void vec2f::operator/=(float d)
{
	x /= d;
	y /= d;
}
vec2f vec2f::operator*(const vec2f& o) const
{
	return vec2f(x*o.x, y*o.y);
}
void vec2f::operator*=(const vec2f& o)
{
	x *= o.x;
	y *= o.y;
}
vec2f vec2f::operator*(float d) const
{
	return vec2f(x*d, y*d);
}
void vec2f::operator*=(float d)
{
	x *= d;
	y *= d;
}
float vec2f::dot(const vec2f& other) const
{
	return other.x*x + other.y*y;
}
float vec2f::sizesq() const
{
	return x*x + y*y;
}
float vec2f::size() const
{
	return sqrt(sizesq());
}
void vec2f::normalize()
{
	float mag = size();
	x /= mag;
	y /= mag;
}
vec2f vec2f::unit() const
{
	vec2f temp(x,y);
	temp.normalize();
	return temp;
}
vec2f operator-(vec2f v)
{
	return vec2f(-v.x, -v.y);
}
